//TODO This is a quick hack to get something working. Should rewrite.
var deliciousService = {
  tagDOM: null,
  setTags: function(tagXML) {
    var updatedXML = tagXML.replace("&", "&amp;");
    this.tagDOM = new DOMParser().parseFromString(updatedXML, "text/xml");
  },
  getTags: function() {
    return this.tagDOM;
  }
};

var gUsername = "";

var myObserver = {
  observe: function(subject,topic,data) {
    switch (topic) {
      case "ext:delicious:defaultUserChanged":
        gUsername = data;
        break;
      case "ext:delicious:tagxmlForDefaultUser":
        deliciousService.setTags(data);
        clearTags();
        loadTags();
        break;
      case "ext:delicious:reloadBookmarks":
        loadSelectedTag();
        break;                
      case "ext:delicious:sidebarSetLoadedBookmarks":
        setLoadedBookmarks(data);
        break;                
    }
  }
};

/**
 * When the sidebar is first loaded, load the user's tags.
 */
function onLoad() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(myObserver,"ext:delicious:defaultUserChanged",false);
    observerService.addObserver(myObserver,"ext:delicious:tagxmlForDefaultUser",false);
    observerService.addObserver(myObserver,"ext:delicious:sidebarSetLoadedBookmarks",false);    
    observerService.addObserver(myObserver,"ext:delicious:reloadBookmarks",false);    
    
    
    // Send message that sidebar is loaded
    observerService.notifyObservers(null,"ext:delicious:sidebarLoaded","");
    
    window.onunload = function() {
      observerService.removeObserver(myObserver,"ext:delicious:defaultUserChanged");
      observerService.removeObserver(myObserver,"ext:delicious:tagxmlForDefaultUser");
      observerService.removeObserver(myObserver,"ext:delicious:sidebarSetLoadedBookmarks");
      observerService.removeObserver(myObserver,"ext:delicious:reloadBookmarks");      
    };
}

/**
 * Retrieves user's tags from the del.icio.us server.
 */
function loadTags()
{
    try
    {
        var tagsTree = document.getElementById('delicious-sidebar-tags-tree');
        var xmlDOM = deliciousService.getTags();
        if (xmlDOM == false || xmlDOM == null) {
            return;
        }

        var root = xmlDOM.documentElement;
        var myTags = root.getElementsByTagName("tag");
        
        var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
        RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);
        
        var RDFC = Components.classes['@mozilla.org/rdf/container;1'].getService();
        RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);
        
        var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
        RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);
        
        var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance();
        ds = ds.QueryInterface(Components.interfaces.nsIRDFDataSource);
        
        // create our root nodes
        var rootNode = RDF.GetResource("urn:root");
        var sequenceNode = RDF.GetResource("urn:root:seq");
        // Root node in tree
        ds.Assert(rootNode, RDF.GetResource("http://delicious.mozdev.org/RDF#tags"), sequenceNode, true);
        
        RDFCUtils.MakeSeq(ds, sequenceNode);
        RDFC.Init(ds, sequenceNode);       
        
        tagsTree.database.AddDataSource(ds);
        
        for (var i = 0; i < myTags.length; i++) 
        {
            var tagName = myTags[i].getAttribute("tag");
            var count = myTags[i].getAttribute("count");
            var countSort = leftPad(myTags[i].getAttribute("count"));
            
            var newURI = "urn:root:file:" + i;

            // add the new element
            RDFC.AppendElement(RDF.GetResource(newURI));
            
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#name"),
                RDF.GetLiteral(tagName), true);
            
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#count"),
                RDF.GetLiteral(count), true);
            
            // "countSort" is used as a hidden column that allows the "count"
            // column to be sorted properly (numerically instead of
            // lexically). Padding the number makes the two equivalent, but
            // you don't want to *see* the padded version.
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#countSort"),
                RDF.GetLiteral(countSort), true);
        }
        tagsTree.builder.rebuild();
    }
    catch(e) { alert("Error loading tags: "+e); }
}

function leftPad(number)
{
    var padded=number;
    while(padded.length<5) padded="0"+padded;
    return(padded);
}

function clearTags()
{
    var tree = document.getElementById('delicious-sidebar-tags-tree');
    clearTree(tree);
}

function reloadTags()
{    
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    
    clearTags();
    observerService.notifyObservers(null,"ext:delicious:sidebarReloadTagsRequest","");
    
    clearFeeds();
    observerService.notifyObservers(null,"ext:delicious:sidebarReloadBookmarksRequest","");
}

function clearFeeds()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    clearTree(tree);
}

/**
 * Fix for getCellText. In Firefox <1.5 it took the column as a string, in Firefox 1.5beta onwards as a Column.
 */
function columnFromTree(aTree, aColumnName)
{
  if (aTree.columns) {
    return aTree.columns[aColumnName];  // Firefox 1.5+
  } else {
    return aColumnName;  // Firefox <1.5
  }
}

/**
 * Queries the selected tags and loads the results into the bookmark list.
 */
function loadSelectedTag()
{   
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    if(tagsTree.view.selection.count == 0)
    {
        return false;
    }
    else
    {
        window.status="Loading tags...";
        var start = new Object();
        var end = new Object();
        var numRanges = tagsTree.view.selection.getRangeCount();
        var tags = "";
        var column = columnFromTree(tagsTree, "name_column");

        // Discontiguous selections are broken up into ranges, so 
        // we loop over each range in turn.
        for(var t=0;t<numRanges;t++)
        {
            tagsTree.view.selection.getRangeAt(t,start,end);
            for(var v=start.value;v<=end.value;v++) {
                tags+=tagsTree.view.getCellText(v, column) + "+";
                // Once the RSS feed is fixed, this needs to be enabled
                // in order to allow tags like "C++".
                //tags+="\""+tagsTree.view.getCellText(v, "name") + "\"+";
            }
        }

        tags=tags.substring(0,tags.length-1);

        loadFeed(tags);
        window.status="Done";
        return true;
    }
}

/**
 * Query del.icio.us for bookmarks under the specified tags and load
 * the tags into the bookmarks tree.
 */
function loadFeed(tags)
{
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.notifyObservers(null,"ext:delicious:sidebarLoadBookmarksRequest", tags);
}


/**
 * Fills the tree with bookmarks after they were retrieved by the deliciousService.
 */
function setLoadedBookmarks(bookmarksXML) {
  if (bookmarksXML == false || bookmarksXML == null) {
  	return;
  }
    
	try
	{			
			var bookmarksTree = document.getElementById('delicious-sidebar-bookmarks-tree');
			
			var xmlDOM = new DOMParser().parseFromString(bookmarksXML, "text/xml");
		
			var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
			RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

			var RDFC = Components.classes['@mozilla.org/rdf/container;1'].getService();
			RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

			var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
			RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

			var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance();
			ds = ds.QueryInterface(Components.interfaces.nsIRDFDataSource);

			// create our root nodes
			var rootNode = RDF.GetResource("urn:root");
			var sequenceNode = RDF.GetResource("urn:root:seq");
			// Root node in tree
			ds.Assert(rootNode, RDF.GetResource("http://delicious.mozdev.org/RDF#bookmarks"), sequenceNode, true);

			RDFCUtils.MakeSeq(ds, sequenceNode);
			RDFC.Init(ds, sequenceNode);

			// Before setting the new data source
			// get rid of all old ones
			clearFeeds();
			bookmarksTree.database.AddDataSource(ds);

			var nsResolver = xmlDOM.createNSResolver( xmlDOM.ownerDocument == null ? xmlDOM.documentElement : xmlDOM.ownerDocument.documentElement);
			var bookmarks = xmlDOM.evaluate("//post", xmlDOM, null, window.XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

			for ( var i=0 ; i < bookmarks.snapshotLength; i++ )
			{			
					var title = bookmarks.snapshotItem(i).getAttribute("description");
					var extended = bookmarks.snapshotItem(i).getAttribute("extended");
					var url = bookmarks.snapshotItem(i).getAttribute("href");
				
				  // the two others are required fields!
					if (extended == null) {
						extended = "";
					}
				
					var newURI = "urn:root:file:" + i;

					// add the new element
					RDFC.AppendElement(RDF.GetResource(newURI));

					ds.Assert(RDF.GetResource(newURI),
							RDF.GetResource("http://delicious.mozdev.org/RDF#title"),
							RDF.GetLiteral(title), true);

					ds.Assert(RDF.GetResource(newURI),
							RDF.GetResource("http://delicious.mozdev.org/RDF#description"),
							RDF.GetLiteral(extended), true);
							
					ds.Assert(RDF.GetResource(newURI),
							RDF.GetResource("http://delicious.mozdev.org/RDF#url"),
							RDF.GetLiteral(url), true);							
			}
			bookmarksTree.builder.rebuild();
	}
	catch(e) { alert("Error loading bookmarks: "+e); }
  
}

//
// Load link
//
function openSingleBookmark(event, isDblClick)
{
		var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
		var column = columnFromTree(tree, "link_column");
		var bookmarkUrl = tree.view.getCellText(tree.currentIndex, column);

		var winMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var winEnumerator = winMediator.getZOrderDOMWindowEnumerator('navigator:browser', false);
    var window = winEnumerator.getNext();

		if (isDblClick) {			
			getContentBrowser().loadURI(bookmarkUrl);		
    } else if (event.ctrlKey || (event.button == 1)) {
			var newTab = getContentBrowser().addTab(bookmarkUrl);
			getContentBrowser().selectedTab = newTab;
    } 
    
    return;
}

function openMultipleBookmarks(loadFirstBookmarkInNewTab)
{
    // There has to be an easier way to open a new tab, but
    // the getBrowser().addTab(url) I see elsewhere doesn't work here.
    var winMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var winEnumerator = winMediator.getZOrderDOMWindowEnumerator('navigator:browser', false);
    var window = winEnumerator.getNext();

    const bmsTree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var start = new Object();
    var end = new Object();
    var numRanges = bmsTree.view.selection.getRangeCount();
    var tags = "";
    var first = true;
    var column = columnFromTree(bmsTree, "link_column");

    for(var t=0;t<numRanges;t++)
    {
        bmsTree.view.selection.getRangeAt(t,start,end);
        for(var v=start.value;v<=end.value;v++)
        {
            var bookmarkUrl = bmsTree.view.getCellText(v, column);
            if(first && !loadFirstBookmarkInNewTab)
            {
                getContentBrowser().loadURI(bookmarkUrl);	
                first=false;
            }
            else getContentBrowser().addTab(bookmarkUrl);
        }
    }

    return;
}

function deleteBookmarks()
{
    
    const bmsTree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var start = new Object();
    var end = new Object();
    var numRanges = bmsTree.view.selection.getRangeCount();
    var tags = "";
    var first = true;
    var column = columnFromTree(bmsTree, "link_column");

		var lastItem = bmsTree.view.rowCount == 1;

    for(var t=0;t<numRanges;t++)
    {
        bmsTree.view.selection.getRangeAt(t,start,end);
        for(var v=start.value;v<=end.value;v++)
        {
            var bookmarkUrl = bmsTree.view.getCellText(v, column);
						
		        var answer = confirm("Delete bookmark with url '" + bookmarkUrl +"'?");
		        if(answer)
		        {
		            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		            observerService.notifyObservers(null,"ext:delicious:sidebarDeleteBookmarkRequest", bookmarkUrl);
		            
		            if (lastItem) {
									reloadTags();		            
		            }		            
		            
		            return true;
		        }
		        else
		        {
		            return false;
		        }

        }
    }

    return false;
}

//
// Rename tag
//
function renameTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    var column = columnFromTree(tagsTree, "name_column");
    const tag = tagsTree.view.getCellText(tagsTree.currentIndex, column);
    const count = tagsTree.view.selection.getRangeCount();
    
    if(count == 0)
    {
        alert("No tag selected to rename");
        return false;
    }
    else
    {
        var name = prompt("Enter new name for tag '" + tag + "'");
        if(name.length > 0)
        {
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.notifyObservers(null,"ext:delicious:sidebarRenameTagRequest","from:"+tag+"&&__to:"+name);
            return true;
        }
        else
        {
            return false;
        }
    }
}

//
// Removes all datasources from a tree
//
function clearTree(tree)
{
    var datasources = tree.database.GetDataSources();
    while(datasources.hasMoreElements()){
            var datasource = datasources.getNext();
            datasource = datasource.QueryInterface(Components.interfaces.nsIRDFDataSource);
            tree.database.RemoveDataSource(datasource);
    }

    tree.builder.rebuild();
}

function populateBookmarkToolTip(event) {		
	const bmsTree = document.getElementById('delicious-sidebar-bookmarks-tree');
	var row = {}, column = {}, part = {};
	var boxobject = bmsTree.boxObject;
	
	boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
	
  var rowIndex = boxobject.getRowAt(event.clientX, event.clientY);
  
  if (rowIndex < 0) {
  	return;
  }
  
  var title = bmsTree.view.getCellText(rowIndex, bmsTree.columns.getColumnAt(0));
	var descr = bmsTree.view.getCellText(rowIndex, bmsTree.columns.getColumnAt(1));
	var url   = bmsTree.view.getCellText(rowIndex, bmsTree.columns.getColumnAt(2));
	
	var bookmarkToolTipTitle = document.getElementById("bookmarkToolTipTitle");  
	var bookmarkToolTipDescr = document.getElementById("bookmarkToolTipDescr");
	var bookmarkToolTipURL = document.getElementById("bookmarkToolTipURL");

		
	bookmarkToolTipTitle.setAttribute("value", title);
	bookmarkToolTipDescr.setAttribute("value", descr);
	bookmarkToolTipURL.setAttribute("value", url);
}

function editBookmarks() {
    const bmsTree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var start = new Object();
    var end = new Object();
    var numRanges = bmsTree.view.selection.getRangeCount();
    var columnLink = columnFromTree(bmsTree, "link_column");
    var columnTitle = columnFromTree(bmsTree, "title_column");

    for(var t=0;t<numRanges;t++) {
        bmsTree.view.selection.getRangeAt(t,start,end);
        for(var v=start.value;v<=end.value;v++) {
            var bookmarkUrl = bmsTree.view.getCellText(v, columnLink);
            var title = bmsTree.view.getCellText(v, columnTitle);
						
						// load the add dialog with the bookmarkUrl
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.notifyObservers(null,"ext:delicious:editBookmarkRequest", bookmarkUrl + ";;;" + title);						
        }
    }

    return;
}

/**
 * Answers the current browser to open a tab or window or stuff.
 */
function getContentBrowser() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
	var topWindowOfType = windowManager.getMostRecentWindow("navigator:browser");
	if (topWindowOfType) {
		return topWindowOfType.document.getElementById('content');
	}
	return null;
}